package com.example.museum2;

import android.app.LoaderManager;
import android.content.CursorLoader;
import android.content.Intent;
import android.content.Loader;
import android.database.Cursor;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;

import androidx.appcompat.app.AppCompatActivity;

public class SummaryActivity extends AppCompatActivity implements LoaderManager.LoaderCallbacks<Cursor> {

    public CartAdapter mAdapter;
    public static final int LOADER = 0;
    TextView price_test;
    String price_test_holder;
    int price_test_holder_integer, sum;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_summary);


        Button clearthedata = findViewById(R.id.clearthedatabase);
        Button pay = findViewById(R.id.pay);

        price_test = findViewById(R.id.price_test);


        Intent intent = getIntent();
        Bundle bundle = intent.getExtras();

        price_test_holder = bundle.getString("price_test");
        price_test_holder_integer =  Integer.parseInt(price_test_holder);

        Singleton.getInstance().addToArray(price_test_holder_integer);

        sum = Singleton.getInstance().sum();
        price_test.setText("Total:£ " + sum);


        clearthedata.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                int deletethedata = getContentResolver().delete(OrderContract.OrderEntry.CONTENT_URI, null, null);
                Singleton.getInstance().delete();
                price_test.setText("Total: £0 ");
            }
        });

        getLoaderManager().initLoader(LOADER, null, this);

        ListView listView = findViewById(R.id.list);
        mAdapter = new CartAdapter(this, null);
        listView.setAdapter(mAdapter);


        pay.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                // Going to Dashboard activity after login success message.
                Intent intent = new Intent(SummaryActivity.this, Checkout.class);

                startActivity(intent);
            }
        });


    }

    @Override
    public Loader<Cursor> onCreateLoader(int id, Bundle args) {
        String[] projection = {OrderContract.OrderEntry._ID,
                OrderContract.OrderEntry.COLUMN_NAME,
                OrderContract.OrderEntry.COLUMN_PRICE,
                OrderContract.OrderEntry.COLUMN_QUANTITY,

        };

        return new CursorLoader(this, OrderContract.OrderEntry.CONTENT_URI,
                projection,
                null,
                null,
                null);

    }

    @Override
    public void onLoadFinished(Loader<Cursor> loader, Cursor data) {
        mAdapter.swapCursor(data);
    }

    @Override
    public void onLoaderReset(Loader<Cursor> loader) {

        mAdapter.swapCursor(null);
    }
}